#==============================================================================
#
#  $Id$
#
"""
   Buffer type definitions for minimal terminals - these are used by the 
   output of launched subprocesses.
"""
#
#  Copyright (C) 2008 Google Inc.
#
#   This file is part of SpugEdit.
#
#   SpugEdit is free software: you can redistribute it and/or modify it under
#   the terms of the GNU Lesser General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   SpugEdit is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with SpugEdit.  If not, see <http://www.gnu.org/licenses/>.
#
#==============================================================================

from yed import TextRules
from yed.core import RegionConfig, registerBufferType, Struct, \
    createAttrConfig
from default import DefaultBufferType

class TermBufferType(DefaultBufferType):
    name = 'term'
    config = RegionConfig(
        DefaultBufferType.config,
        rules = TextRules(),
    )
    regions = Struct(
        DefaultBufferType.regions,
        meta = createAttrConfig(
            foreground = 'white',
            background = 'midnight blue'
        )
    )

registerBufferType(TermBufferType())
