#==============================================================================
#
"""
    The yed manual.  Stuck this in a source file because package data didn't 
    work for me.
"""
#
#  Copyright (C) 2008 Google Inc.
#
#   This file is part of SpugEdit.
#
#   SpugEdit is free software: you can redistribute it and/or modify it under
#   the terms of the GNU Lesser General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   SpugEdit is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with SpugEdit.  If not, see <http://www.gnu.org/licenses/>.
#
#==============================================================================

data = """

                            The Yed Programmers Editor
                            ==========================

Welcome to Yed!  Press *F1* at any time to return to this document.

1.0 Cheat Sheet
---------------

*F1*::
    Show this help page.
*F2*::
    Save the buffer to file.  Writes the current buffer to a file.
*F3*::
    Delete the current buffer.  Deletes the buffer, prompts you if the buffer 
    has been modified.  If there's only one buffer, shuts down the editor.
*Ctrl-F3*::
    Shutdown the editor.  Prompts you to save any unsaved buffers.
*F4*::
    Save and delete the buffer.
*F6*::
    Select the parent buffer.
*F7*::
    Insert text at the cursor column of every line of the selection.
*Ctrl-F7*::
    Delete text at the cursor column of every line of the selection.
*F8*::
    Load a file.  Creates a new buffer and reads a file into it.  Hit the Tab 
    key to do tab-completion, hit escape to abort.
*F9*::
    Create or select the python command buffer.  In the python buffer, 
    execute the last command.
*F10*::
    Select a buffer by name.
*Ctrl-F10*::
    Select a buffer by name and move the buffer in the buffer ring so 
    that it immediately follows the current buffer.
*Ctrl-F*::
    Incremental search forward.
*Ctrl-R*::
    Incremental search backwards.
    
    *Ctrl-I*::
        In incremental search mode, disable case sensitivity.
*Ctrl-N*::
    Go to a specific line number.
*Up*, *Ctrl-K*::
    Up one line.
*Down*, *Ctrl-J*::
    Down one line.
*Left*, *Ctrl-H*::
    Left one character
*Right*, *Ctrl-L*::
    Right one character.
*Ctrl-Z*::
    Undo last change
*Ctrl-Shift-Z*::
    Redo last change.
*Esc*::
    Yed command prompt.

2.0 Commands
------------

Yed has a command line just like most other editors.  To enter it, use the 
Esc key.  You can enter built-in commands or yedlet commands (see "Extending 
and Customizing" below).

The following built-in commands are supported:

#mount# /path/ /host:port/ /auth-token/::
    mount a remote filesystem.
#umount# /path/::
    unmount the remote filesystem on the given path.
#yedlet# [-ide] /name/::
    create, edit or delete a yedlet.

3.0 Instances
-------------

Instances allow you to customize yed and maintain a persistent state for 
multiple independent tasks.  For example, while developing extensions (or 
making changes to yed itself) you might want to run another instance of the 
editor that is separate from the "safe" instance that you do your normal 
development to protect your precious editing environment from falling debris. 
Alternately, you might want to maintain one version of yed strictly for 
browsing documentation - containing its own set of buffers and customized 
bindings.

When you start yed without the "-i" option, you get the "Default" instance.  
The instance name is identified on the yed title bar.  "-i" allows you to 
specify an alternate instance.  If you start yed under an instance that is 
already running, the assumption is that you want to communicate with the 
existing instance.  For example, if we're already running the default 
instance, the command "yed foo bar" will attempt to add the files "foo" and 
"bar" from the current directory to the default instance.

Every instance has a name that corresponds to a 
subdirectory under `$HOME/.yed/instances`.

4.0 Remote Access
-----------------

A primary feature of yed is that it can communicate with other yed processes.  
The most basic example of this is when adding other files to an existing 
instance.  For example, to add the "foo" file to a running "Default" instance, 
we can simply run "yed foo".

If we wanted to wait for the use to finish editing "foo" and close its buffer,
we could use the blocking option: "yed -b foo".  This is very useful for 
things like version control programs that want to bring up an editor to allow 
the user to write comments or resolve conflicts.

There are a host of other things that we can do from the command line to a 
running instance:

-S, --saveAll::
    Save all modified buffers.
-L, --reloadAll::
    Reload all buffers that have been modified on disk.
-l, --ls::
    List the names of all buffers currently in the buffer ring.
-t, --getToken::
    Generate a random authentication token to allow us to connect to yed over 
    `TCP/IP`.

By default, the yed command communicates to an existing instance through a 
unix domain socket in the instance directory.  Yed also brings up an interface 
on an ephemeral `TCP/IP` port, but use of this interface requires an 
authentication token.

Authentication tokens are generated upon request.  An initial authentication 
token is printed out when the editor is started, along with the initial TCP\/IP 
port.  To generate a new authentication token, invoke yed with the "-t" 
option.

Yed can also use remote instances of itself as a file server.  This can be 
done either by using slave mode - in which the entire filesystem is proxied 
through a remote master - or through the mount command, which allows you to 
mount the remote filesystem on part of yed's local path.

To run in slave mode, use the -m option with the -a option for authentication. 
For example:

{{
    yed -m hostname:38455 -a SzDi0Z+b4YwedBWH
}}

The port number and authentication token can be obtained from the remote yed 
instance during startup.

The mount command is a little bit more flexible, and allows you to essentiall 
maintain a virtual filesystem composed of the filesystems of multiple yed 
instances.  To use it, press the escape key to bring up the command line, then 
enter the mount command:

{{
    mount /other hostname:38455 SzDi0Z+b4YwedBWH
}}

The first argument is the path to mount the file on, the second is the remote 
instance address, and the third is the authentication token.  The filesystem 
can be unmounted using the "umount" command:

{{
    umount /other
}}

Note that all remote file interfaces have an advantage over other, external 
means of mounting remote file systems in that they read and write _through_ 
the remote yed instance: so if the file is already buffered and modified in 
the remote yed, you get the modifications.  Likewise, when the file is 
written, the copy of the file in the remote buffer gets modified.

By default, yed picks a random port allocated by the operating system on 
startup and a random authentication token.  This isn't optimal: you need to 
obtain the new port number every time you restart the remote instance.  
However, it is trivial to configure yed to bind to a well known port and use
the same authentication token.  The following modular extension is an example:

{{
    # get the global application object
    app = getApp()

    # add a non-random authentication token
    app.auth.tokens.add('my-s3cr3t-t0k3n')
    
    # bind to port 8500
    app.communicator.addTCPServer(8500)
}}

Copy this into an init file in a directory under the instance director that 
you want to configure, for example 
"`~/.yed/instances/Default/ext/custom/init`".  See the section on modular 
extensions below for more information.  Note that you'll want to configure 
this kind of thing at the instance level, not the global level: different 
instances will each need their own port.  You could configure the 
authentication token at the global level, if you want all of your instances to 
be accessible with the same authentication token.

After doing this, you can happily "`mount /other hostname:8500 
my-s3cr3t-t0k3n`".  You could even configure your client instances to 
automatically mount on startup by giving them the following script:

{{
    from yed.comm import getTCPRemote
    
    # create a remote filer
    remote = getTCPRemote(app, 'hostname', 8500)
    remote.authToken = 'my-s3cr3t-t0k3n'
    filer = RemoteFiler(remote)
    
    # mount it
    getApp().filer.mount('/other', filer)
}}

*Important Note: yed currently doesn't encrypt its connections.*  All TCP 
traffic between yed instances is sent plain-text and is trivially visible to 
anyone with access to the network.  If you are using yed's remote 
communication features, it is highly recommended that you dispatch them over 
an ssh tunnel.  If you replace 'hostname' with 'localhost' in the examples 
above, the following command will create such a tunnel:

{{
    ssh -L 8500:localhost:8500 hostname
}}

Also, (obviously) if you are putting authentication tokens into your config 
files, make sure that they are not world-readable.  If you don't know and 
trust the people with root on the machine in question, don't do this at all.

5.0 Extending and Customizing
-----------------------------

Yed currently supports two extension mechanisms: modular extensions and 
yedlets.  

Modular extensions are subdirectories installed in the `$HOME/.yed/ext` or 
instance specfic `$HOME/.yed/instances/$INSTANCE/ext` directories.  They are 
initialized at load time.  When the editor starts, all of the module 
extensions are scanned and initialized.  This makes them suitable for all 
sorts of customizations, including overriding the default keybindings.

In contrast, yedlets are a lightweight mechanism for defining commands as 
complete scripts.  They are loaded on demand, and reloaded when the script has 
a newer mtime than the last one loaded in memory.  These dynamic load features 
make them suitable for quickly automating editing tasks.  Yedlets live in the 
yedlet directories `$HOME/.yed/yedlet` and 
`$HOME/.yed/instances/$INSTANCE/yedlet`.

5.1 Modular Extensions
----------------------

Modular extensions allow you to extend yed with large chunks of functionality 
(including extension specific modules and packages) with the limitation that 
they are all loaded during initialization: a restart is required to install a 
new extension.

Modular extensions are added to the appropriate extension ("ext") directory 
under yed's directory tree.  For extensions to be loaded by all instances, 
this is `$HOME/.yed/ext`.  For extensions exclusive to particular instances, 
it is `$HOME/.yed/instances/$INSTANCE/ext`.

An extension directory should contain an "init" file and may contain a "lib" 
directory.  The "init" file is a python script containing statements to be 
executed when the extension is run.  The init scripts have access to 
everything in the yed codebase.  They can define new commands, register new 
buffer types, bind keys, set buffer attributes and start servers - and 
probably lots of other things.


5.1.1 Basic Customization
'''''''''''''''''''''''''

To customize your colors, bindings and fonts, create a subdirectory called 
"custom" under `$HOME/.yed/ext`:

{{
    mkdir -p $HOME/.yed/ext/custom
}}

Create an "init" file in this directory with your customizations in it.

The following is an example configuration file:

{{
    from yed.core import Font
    from yed.buf.default import DefaultBufferType
    
    # Modifying "DefaultBufferType" effects the default properties inherited 
    # by every buffer.  You can modify settings for specific buffer types by 
    # changing properties in the appropriate class, for example 
    # "yed.buf.python.PythonBufferType".  See "Configuration Objects" below 
    # for information on "config" and "regions"
    DefaultBufferType.config.attrs.foreground = 'black'
    DefaultBufferType.config.attrs.background = 'gray'
    DefaultBufferType.config.attrs.insertbackground = 'DarkGreen'
    DefaultBufferType.config.font = Font('-*-courier-*-r-*-*-10-*-*-*-*-*-*-*')
    DefaultBufferType.regions.comment.attrs.foreground = 'DarkGreen'
    DefaultBufferType.regions.comment.font = Font('-*-lucida-*-r-*-*-*-*-*-*-*-*-*-*')
    DefaultBufferType.regions.symbol.attrs.foreground = 'DarkBlue'
    DefaultBufferType.regions.string.attrs.foreground = 'DarkMagenta'
    
    # bind "control mousebutton 1" to the "foo" yedlet.
    DefaultBufferType.config.bindings['<Control-Button-1>'] = \
        YedletCommandFactory(app.getYedletDir(), 'foo')
}}

4.1.2 Configuration Objects
'''''''''''''''''''''''''''

Every buffer in yed has an associated BufferType object.  The BufferType 
defines text attributes, fonts, bindings, and syntax rules for the buffer and 
all of its regions.

"Regions" are simply Tk Text widget tags - see "man text" for more 
information.  They are mainly used for syntax highlighting in yed, but they 
have a lot of power that is currently unused - such as the ability to 
define custom bindings.

Every BufferType class object has a collection of attributes.  Of primary 
concern for customization are the "config" and "regions" attributes.  "config" 
is a RegionConfig object, and "regions" is a Struct object with an attribute 
for every region type that we wish to specialize.  The value of the region 
type attributes are also RegionConfig objects.  So, in summary, the BufferType 
objects consist of one RegionConfig for the entire buffer 
(BufferType.config), and multiple RegionConfigs for each of the 
regions\/tk-tags (BufferType.regions./region-name/).

RegionConfig objects are derived from Struct objects.  Struct objects are 
basically dictionaries whose keys are accessible as attributes.  Two other 
important things to be aware of with Struct objects are:

-   They can delegate: so for example, the config structs of a derived 
    BufferType class typically delegate to the config structs of the base 
    class.
-   They allow you to provide constructed default values.  For example, if you 
    access the "attrs" attribute of a RegionConfig object, and none is 
    defined, it constructs one that delegates to the attrs object of its own 
    delegate.

This combination of features allows you to assign general values at the more 
general BufferType classes (like DefaultBufferType) and safely override them 
in the more specific BufferType classes.  (We could achieve the same effect 
with inheritence, class objects, and meta-classes, but the latter seemed to 
be a more confusing implementation).

RegionConfig objects support the following attributes:

attrs::
    Another Struct object mapping attribute names (Tk option names) to 
    values.
font::
    A Font object.  Fonts are Tk font objects wrapped in a class that allows 
    you to override the width of a space character (this is useful due to what 
    appears to be a bug in Tk: it seems to get this width wrong for a font 
    name of "fixed").
bindings::
    Another Struct object mapping Tk event types to factories that return 
    Command objects (they accept the top-level widget as input, a questionable 
    design decision that is likely to go away).
rules::
    An instance of a class derived from Rules.  Rules classes define the basic 
    syntax rules for a region - for example, what to insert when the Enter key 
    is pressed.  Rules objects also do all of the initial parsing of the 
    buffer in order to assign regions based on syntax patterns.

4.2 Yedlets
-----------

Yedlets are simple command scripts that are reoaded whenever they are changed 
on disk.  For this reason, they are useful for quick, interactive automation 
of editing tasks.

The easiest way to create a yedlet is with the yedlet command.  Hit the escape 
key to bring up the command line, then type:

{{
    yedlet foo
}}

Where "foo" is the name of the command.

You can also directly edit yedlet files in `$HOME/.yed/yedlet` and 
`$HOME/.yed/$INSTANCE/yedlet` - the yedlet command is simply a shortcut.

The yedlet command also accepts several options:

*-i*::
    Use the instance yedlet directory instead of the global one.  This allows 
    you to work with yedlets that are specific to the instance.
*-d*::
    Delete the yedlet instead of editing.
*-e*::
    Don't look for yedlet names on the command line, bring up the file browser 
    and allow the user to select from there.

The yedlet itself is simply a python script.  Yedlets script can use the 
following local variables:

src::
    A file object that allows you to read from the marked region.
dst::
    A file object that allows you to write to the marked region.
buf::
    [yed.core.Buffer] the current buffer at the time the yedlet is run.
top::
    [yed.core.Top] the current toplevel that the yedlet is run from.
start::
    [str] the index of the start of the marked region (or the cursor if there 
    is no marked region)
end::
    [str] the index of the end of the marked region (or the cursor if there is 
    no marked region)
args::
    [list<str>] the command line arguments to the yedlet.  These exclude the 
    name of the yedlet itself.
context::
    [yed.core.CommandContext] the context object that the yedlet was executed 
    under.

If the yedlet sets "context.result" to true, then all further event processing 
is aborted.  This is useful for binding yedlets to events, which can be done 
in a customization script as follows:

{{
    from yed import getApp, YedletCommandFactory
    from yed.buf.default import DefaultBufferType
    
    DefaultBufferType.config.bindings['<Control-Button-1>'] = \
        YedletCommandFactory(getApp().getYedletDir(), 'my_yedlet')
}}
    
    
"""